#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif

#define PIN 3
Adafruit_NeoPixel strip = Adafruit_NeoPixel(30, PIN, NEO_GRB + NEO_KHZ800);

int buttonOne = 0, buttonTwo = 0, buttonThree = 0;
int buttonStateOne = 0, buttonStateTwo = 0, buttonStateThree = 0;

int slowCnt = 0;

int slow = 0;

int screen = 0;
int screenRGB = 0;

int numberOfLeds = 0, numberOfLedsOld = 0;

int red = 0, green = 0, blue = 0;

int rainbowDelay = 20;

int screenEffect = 0;

int number();
int RGBset();
void rainbow(uint8_t);
void rainbowCycle(uint8_t);
void theaterChase(uint32_t, uint8_t);
uint32_t Wheel(byte WheelPos);

void setup() {
  
  TCCR0B = (1 << CS01); // предделитель частоты
  TIMSK = (1 << TOIE0); // разрешение прерывания по переполнению
  sei();

  pinMode(0, INPUT);
  pinMode(1, INPUT);
  pinMode(2, INPUT);
  
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);

  strip.setBrightness(255);
  strip.begin();
  strip.show();
}

void loop() {
  if(screen == 0) number();
  if(screen == 1) RGBset();
  if(screen == 2 && screenEffect == 0) rainbowCycle(rainbowDelay);
  if(screen == 2 && screenEffect == 1) {
    theaterChase(strip.Color(250, 0, 0), rainbowDelay); 
    theaterChase(strip.Color(0, 0, 250), rainbowDelay); 
  }
  if(screen == 2 && screenEffect == 2){
    theaterChase(strip.Color(250, 0, 0), rainbowDelay); 
    theaterChase(strip.Color(0, 0, 250), rainbowDelay); 
    theaterChase(strip.Color(0, 250, 0), rainbowDelay);
  }
  if(screen == 2 && screenEffect == 3){
    theaterChaseRainbow(100);
  }
  if(screen == 2 && screenEffect == 4){
    rainbow(500 + rainbowDelay);
  }
  if(screen == 2 && screenEffect == 5){
    randomColor(30000 + rainbowDelay*5);
  }
 
}

ISR(TIMER0_OVF_vect)
{
  if(digitalRead(2) == 0) { buttonStateOne++; if(buttonStateOne > 400) {buttonStateOne = 0; buttonOne = 1;} }
  if(digitalRead(2) == 1) { buttonStateOne--; if(buttonStateOne < 0) {buttonStateOne = 0; buttonOne = 0;} }

  if(digitalRead(1) == 0) { buttonStateTwo++; if(buttonStateTwo > 400) {buttonStateTwo = 0; buttonTwo = 1;} }
  if(digitalRead(1) == 1) { buttonStateTwo--; if(buttonStateTwo < 0) {buttonStateTwo = 0; buttonTwo = 0;} }

  if(digitalRead(0) == 0) { buttonStateThree++; if(buttonStateThree > 400) {buttonStateThree = 0; buttonThree = 1;} }
  if(digitalRead(0) == 1) { buttonStateThree--; if(buttonStateThree < 0) {buttonStateThree = 0; buttonThree = 0;} }

  if(buttonOne == 1 && buttonThree == 1) {
    screen++;
    if(screen == 3  ) screen = 0;
    buttonOne = 0;
    buttonThree = 0;
  }

  if(screen == 1 && buttonOne == 1){
    screenRGB++;
    buttonOne = 0;
    if(screenRGB == 3) screenRGB = 0;
  }

   if(screen == 2 && buttonOne == 1){
    screenEffect++;
    buttonOne = 0;
    if(screenEffect == 6) screenEffect = 0;
  }

  if(screen == 2){
    if(buttonThree == 1){ rainbowDelay++; buttonThree = 0;}
    if(buttonTwo == 1){ rainbowDelay--; buttonTwo = 0;}
    if(rainbowDelay < 10) rainbowDelay = 10;
  }

  slowCnt++;
  if(slowCnt == 80){
    slow = 1;
    slowCnt = 0;
  }

  if(screen != 1) digitalWrite(4, LOW);
 
}

int number(){
  if(buttonThree == 1) {numberOfLeds++; buttonThree = 0;}
  if(buttonTwo == 1) {numberOfLeds--; buttonTwo = 0;}

  if(numberOfLeds < 1) numberOfLeds = 1;

  if(numberOfLeds > numberOfLedsOld){
    strip.setPixelColor(numberOfLeds-1, strip.Color(125, 125, 125)); 
  
    numberOfLedsOld = numberOfLeds;
  }

  if(numberOfLeds < numberOfLedsOld){
    strip.setPixelColor(numberOfLedsOld-1, strip.Color(0, 0, 0)); 
    numberOfLedsOld = numberOfLeds;
  }
  strip.show();
}

int RGBset(){
  if(screenRGB == 0 && buttonTwo == 1 && slow == 1){ red--; slow = 0; if(red < 0) {red = 0;} digitalWrite(4, LOW);}
  if(screenRGB == 0 && buttonThree == 1 && slow == 1){ red++; slow = 0; if(red > 255) {red = 255;} if(red == 255){digitalWrite(4, HIGH);} else {digitalWrite(4, LOW);} }

  if(screenRGB == 1 && buttonTwo == 1 && slow == 1){ green--; slow = 0; if(green < 0) {green = 0;} digitalWrite(4, LOW);}
  if(screenRGB == 1 && buttonThree == 1 && slow == 1){ green++; slow = 0; if(green > 255) {green = 255;} if(green == 255){digitalWrite(4, HIGH);} else {digitalWrite(4, LOW);}}

  if(screenRGB == 2 && buttonTwo == 1 && slow == 1){ blue--; slow = 0; if(blue < 0) {blue = 0;} digitalWrite(4, LOW);}
  if(screenRGB == 2 && buttonThree == 1 && slow == 1){ blue++; slow = 0; if(blue > 255) {blue = 255;} if(blue == 255){digitalWrite(4, HIGH);} else {digitalWrite(4, LOW);}}

  for(int i = 0; i < numberOfLeds; i++){
    strip.setPixelColor(i, strip.Color(red, green, blue)); 
  }
  strip.show();
}

void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j = 0; j < 256; j++) {
    for(i = 0; i < numberOfLeds; i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< numberOfLeds; i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / numberOfLeds) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  //do 10 cycles of chasing
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < numberOfLeds; i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < numberOfLeds; i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}

void theaterChaseRainbow(uint8_t wait) {
  for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for (int q=0; q < 3; q++) {
      for (int i=0; i < numberOfLeds; i=i+3) {
        strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (int i=0; i < numberOfLeds; i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

void randomColor(int delayTime){
  for (int i = 0; i < numberOfLeds; i++) {
        strip.setPixelColor(i, strip.Color(random(0, 255), random(0, 255), random(0, 255)) );    
      }
      strip.show();
      delay(delayTime);
}


